/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: LSGetSubResourcesCommand.m,v 1.2 2003/07/11 16:36:35 jan Exp $
#import "common.h"
#import "LSGetSubResourcesCommand.h"

@implementation LSGetSubResourcesCommand

#if !LIB_FOUNDATION_BOEHM_GC
- (void)dealloc {
  [super dealloc];
}
#endif

- (void)_executeInContext:(id)_context {
  NSArray *assignList = nil;

  LSRunCommandV(_context, @"resource", @"get",
                @"resourceId", [[self object] valueForKey:@"resourceId"],
                nil);

  assignList = [[self object] valueForKey:@"toSubResourceAssignment"];

  if (![assignList isNotNull]) {
    [self setReturnValue:nil];
  }
  else {
    NSEnumerator   *assignEnum = [assignList objectEnumerator];
    NSMutableArray *resultList = [NSMutableArray array];
    id              assignment = nil;
    
    while ((assignment = [assignEnum nextObject])) {
      id tmp = [assignment valueForKey:@"toSubResource"];

      if ([tmp isNotNull])
        [resultList addObject:tmp];
    }
    [self setReturnValue:resultList];
  }
}

- (NSString *)entityName {
  return @"Resource";
}

@end
