/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: LSNewResourceCommand.m,v 1.2 2003/07/11 16:36:35 jan Exp $

#import "common.h"
#import "LSNewResourceCommand.h"

@implementation LSNewResourceCommand

#if !LIB_FOUNDATION_BOEHM_GC
- (void)dealloc {
  [super dealloc];
}
#endif

- (void)_prepareForExecutionInContext:(id)_context {
  id  resourceName = [self valueForKey:@"resourceName"];
  
  [self assert:([self valueForKey:@"type"] != nil)
        reason:@"No type set!"];
  [self assert:((resourceName != nil) && ([resourceName length] != 0))
        reason:@"No resourceName set!"];

  [self takeValue:[NSNumber numberWithInt:1] forKey:@"objectVersion"];
  
  [super _prepareForExecutionInContext:_context];
}

- (void)_executeInContext:(id)_context {
  [super _executeInContext:_context];
  NSLog(@"execute: newResource %@", [self object]);
}

- (NSString*)entityName {
  return @"Resource";
}

// accessor

// key/value coding

#if 0 // what's that ! - hh
- (BOOL)takeValue:(id)_value forKey:(id)_key {
  return [super takeValue:_value forKey:_key];
}

- (id)valueForKey:(id)_key {
  return [super valueForKey:_key];
}
#endif

@end
