/*
  Copyright (C) 2000-2004 SKYRIX Software AG

  This file is part of OpenGroupware.org.

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: imCommon.h,v 1.3 2004/02/17 20:14:46 helge Exp $

#ifndef __NGImap4_common_H__
#define __NGImap4_common_H__

#import <Foundation/Foundation.h>

#if LIB_FOUNDATION_LIBRARY
#  include <extensions/exceptions/GeneralExceptions.h>
#elif NeXT_Foundation_LIBRARY
#  import <NGExtensions/NGObjectMacros.h>
#  import <NGExtensions/NSString+Ext.h>
#  if 0 /* no more FoundationExt */
#    import <FoundationExt/GeneralExceptions.h>
#    import <FoundationExt/NSException.h>
#    import <FoundationExt/MissingMethods.h>
#  endif
#endif

#include <EOControl/EOControl.h>
#include <NGExtensions/NGExtensions.h>
#include <NGStreams/NGStreams.h>
#include <NGStreams/NGNet.h>
#include <NGMime/NGMime.h>
#include <NGMail/NGMail.h>

#if NeXT_RUNTIME || APPLE_RUNTIME
#  ifndef sel_eq
#    define sel_eq(__A__,__B__) (__A__==__B__)
#  endif
#endif

@interface NSObject(OSXHacks)
- (void)subclassResponsibility:(SEL)_acmd;
- (void)notImplemented:(SEL)_acmd;
@end

@interface NSException (setUserInfo)
- (id) setUserInfo: (NSDictionary*) _userInfo;
@end

#endif /* __NGImap4_common_H__ */
