/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: SDXmlRpcAction.h,v 1.3 2004/04/03 19:34:00 helge Exp $

#ifndef __SDXmlRpcAction_H__
#define __SDXmlRpcAction_H__

#include <NGXmlRpc/NGXmlRpcAction.h>
#include <NGXmlRpc/WODirectAction+XmlRpc.h>
#include <OGoDaemon/WODirectAction+SkyDaemon.h>

@class NSArray, NSString, NSException;
@class XmlRpcMethodCall;
@class SDAsyncResultProxy;

@interface SDXmlRpcAction : NGXmlRpcAction
{
}

/* XML-RPC direct action dispatcher ... */

- (id)performActionNamed:(NSString *)_actionName parameters:(NSArray *)_params;

- (id<WOActionResults>)commitFailedAction;

/* command context */

- (BOOL)requiresCommandContextForMethodCall:(NSString *)_method;

/* command context */

- (LSCommandContext *)commandContext;
- (void)flushCurrentCommandContext;

@end

#endif /* __SDXmlRpcAction_H__ */
