/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: SkyRegistryApplication.h,v 1.2 2003/07/11 16:51:38 jan Exp $

#ifndef __SkyRegistryDaemon__SkyRegistryApplication_H__
#define __SkyRegistryDaemon__SkyRegistryApplication_H__

#include <NGObjWeb/WOApplication.h>

@class NSMutableDictionary, NSArray, NSDictionary, NSString, NSTimer, NSURL;
@class NSMutableArray, NSUserDefaults;
@class RegistryEntry, NGXmlRpcClient;

@interface SkyRegistryApplication : WOApplication
{
  NGXmlRpcClient      *masterRegistry;
  NSMutableDictionary *registry;
  NSTimer             *checkTimer;
  int                 checkInterval;
}

/* initialization */

- (BOOL)initRegistry:(NSArray *)_registry;

/* accessors */

- (int)checkInterval;
- (NSMutableDictionary *)registry;
- (NGXmlRpcClient *)masterRegistry;
- (NSUserDefaults *)userDefaults;

@end /* Application */

#endif /* __SkyRegistryDaemon__SkyRegistryApplication_H__ */
