/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: LSWImapMailViewer.h,v 1.4 2003/10/27 18:16:31 jan Exp $

#ifndef __LSWebInterface_LSWImapMail_LSWImapMailViewer_H__
#define __LSWebInterface_LSWImapMail_LSWImapMailViewer_H__

#include <OGoFoundation/LSWViewerPage.h>

@class SkyImapMailListState, NGImap4Context;
@class NSString, NSData;

@interface LSWImapMailViewer : LSWViewerPage
{
@private
  SkyImapMailListState *state;
  NGImap4Context       *imapContext;
  NSData               *mailSource;
  NSString             *tabKey;
  NSString             *mailSourceString;
  NSString             *to;
  NSString             *cc;
  NSString             *bcc;
  NSString             *dispositionNotificationTo;
  id                   mailDS;
  id                   emailContent;
  BOOL                 isToCollapsed;
  BOOL                 isCcCollapsed;
  BOOL                 askToReturnReceipt;
  BOOL                 messageWasUnread;
  BOOL                 viewSourceEnabled;

  id                   downloadAllItem;
  NSArray              *downloadAllObjs;

  struct {
    NSString *next;
    NSString *prev;
    NSString *nextUnread;
    NSString *prevUnread;
    BOOL     nextCalled;
    BOOL     prevCalled;
    BOOL     nextUnreadCalled;
    BOOL     prevUnreadCalled;
  } url;
}

- (void)setTabKey:(NSString *)_tabKey;
- (NSString *)tabKey;

// send Message Disposition Notification
- (id)sendMDN;

@end

#endif /* __LSWebInterface_LSWImapMail_LSWMailViewer_H__ */
