// $Id: OGoDocAction.m,v 1.1 2003/10/22 22:37:24 helge Exp $

#include <NGObjWeb/WODirectAction.h>

@class NGFileManager;
@class EODataSource;

@interface OGoDocAction : WODirectAction
{
  NGFileManager *fileManager;
  EODataSource  *dataSource;
}

@end

#include "common.h"

@implementation OGoDocAction

static BOOL debugOn = YES;

- (void)dealloc {
  [self->fileManager release];
  [self->dataSource  release];
  [super dealloc];
}

/* debugging */

- (BOOL)isDebuggingEnabled {
  return debugOn;
}

/* accessors */

- (id)fileManager {
  return self->fileManager;
}

- (id)dataSource {
  if (self->dataSource == nil)
    self->dataSource = [[[self fileManager] dataSourceAtPath:@"."] retain];
  return self->dataSource;
}

- (OGoNavigation *)navigation {
  return [[self existingSession] navigation];
}

/* actions */

- (id)newAction {
  if ([[[self request] formValueForKey:@"epoz"] boolValue]) {
    [[self context] takeValue:[NSNumber numberWithBool:YES]
		    forKey:@"UseEpoz"];
  }
  return [[self navigation]
	   activateObject:[[self dataSource] createObject]
	   withVerb:@"edit"];
}

@end /* OGoDocAction */
